#
# WiKicker
#
#  HtmlExporter.pm
#
#
# Copyright (C) 2003 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: HtmlExporter.pm,v 1.2 2003/12/29 12:42:27 naney Exp $
#
#

package WiKicker::App::HtmlExporter;

use 5.005;
use strict;
use Getopt::Long;
use WiKicker::App::Configuration;

sub new {
  my $class = shift;

  my $self = bless {}, $class;

  $self->_initialize();

  return $self;
}

sub _initialize {
  my $self = shift;

  my $properties_file = '';
  GetOptions("properties-file=s", \$properties_file);

  unless ($properties_file) {
    die "No --properties-file option\n";
  }
  
  my $configuration = WiKicker::App::Configuration->new(properties_file =>
                                                        $properties_file);
  my $environment = WiKicker::WikiCGI::Environment(configuration => $configuration);

  $self->{configuration} = $configuration;
  $self->{db} = $environment->db;
}

sub db {
  return shift->{db};
}
  

sub run {
  my $self = shift;

  eval {
    $self->db->shared_lock_pages;
  };
  if ($@) {
    warn "Can't lock database: $@";
    return;
  }

  eval {
    my @page_list = $self->db->page_list;
    map { $self->_export_html($_) } @page_list;
  };
  if ($@) {
    warn "Error: $@\n";
  }
  $self->db->unlock_pages;
}

sub _export_html {
  my ($self, $page_name) = @_;
}

1;
