#
# WiKicker
#
#  XML.pm
#
#
# Copyright (C) 2003,2004,2005 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: XML.pm,v 1.3 2005/05/06 13:05:00 naney Exp $
#
#

package WiKicker::CGI::View::XML;

use 5.005;
use strict;
use WiKicker::CGI::View;

use vars qw(@ISA);
@ISA = qw(WiKicker::CGI::View);

sub view {
  my $self = shift;

  $self->set_http_header;
  $self->_make_xml;
}

sub set_http_header {
  my $self = shift;

  my %param;
  if ($CGI::VERSION < 2.57) {
    $param{-type} = 'text/xml; charset=UTF-8';
  }
  else {
    $param{-type} = 'text/xml';
    $param{-charset} = 'UTF-8';
  }
  if (@{$self->response->{cookies}} > 0) {
    $param{-cookie} = $self->response->{cookies};
    $self->response->http_header($self->request->query->header(%param));
  }
}

1;
