#
# WiKicker
#
#  TrackBackError.pm
#
#
# Copyright (C) 2003,2004 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: TrackBackError.pm,v 1.3 2004/05/01 07:34:24 naney Exp $
#
#

package WiKicker::CGI::View::XML::TrackBackError;

use 5.005;
use strict;
use WiKicker::CGI::View::XML;
use WiKicker::HTML;

use vars qw(@ISA);
@ISA = qw(WiKicker::CGI::View::XML);

sub _make_xml {
  my $self = shift;

  my $message = $self->request->attribute('message') || 'error';
  $message = WiKicker::HTML::escape($message);
  my $result =<<__ENDSTR__;
<?xml version="1.0" ?>
<response>
<error>1</error>
<message>$message</message>
</response>
__ENDSTR__

  $self->response->add_content($result);
}

1;
