#
# WiKicker
#
#  Diff.pm
#
#
# Copyright (C) 2003 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: Diff.pm,v 1.1.1.1 2003/05/18 14:03:53 naney Exp $
#
#

package WiKicker::Diff;

use 5.005;
use strict;

use Algorithm::Diff qw(traverse_sequences);

sub make_diff {
  my ($a, $b) = @_;

 my @wiki_page = split(/(?:\r\n?)|\n/, $a);
 my @head_page = split(/(?:\r\n?)|\n/, $b);
 return _make_diff(\@head_page, \@wiki_page);
}

sub _make_diff {
  my ($a, $b) = @_;

  my @del;
  my @add;
  my @result;

  traverse_sequences($a, $b, {
    MATCH     => sub { push(@result, splice(@del), splice(@add));
                       push(@result, ['=',  $a->[$_[0]]]) },
    DISCARD_A => sub { push(@del,    ['-',  $a->[$_[0]]]) },
    DISCARD_B => sub { push(@add,    ['+',  $b->[$_[1]]]) }
  });

  push(@result, splice(@del), splice(@add));
  return \@result;
}

1;
