#
# WiKicker
#
#  Request.pm
#
#
# Copyright (C) 2003,2004 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: Request.pm,v 1.4 2004/08/03 12:55:52 naney Exp $
#
#

package WiKicker::DikiCGI::Request;

use 5.005;
use strict;
use Carp;
use WiKicker::CGI::Request;
use WiKicker::DikiCGI::RequestCommand;

use vars qw(@ISA);

BEGIN {
  @ISA = qw(WiKicker::CGI::Request);
}

sub new {
  my ($class, %options) = @_;

  my $self = bless {}, $class;

  if (exists $options{environment}) {
    $self->environment($options{environment});
  }
  else {
    confess 'no environment';
  }

  if (exists $options{query}) {
    $self->_set($options{query});
  }

  my $cookies = fetch CGI::Cookie;
  $self->cookies($cookies);

  $self->_initialize_user;

  return $self;
}

sub command { shift->{command} }

sub format {
  shift->command->format;
}

sub _set {
  my ($self, $query) = @_;

  $self->_set_query($query);

  $self->{command}
    = WiKicker::DikiCGI::RequestCommand->new(path_info => $query->path_info);

  $self->action('read');
}

1;
