#
# WiKicker
#
#  HTML.pm
#
#
# Copyright (C) 2003,2004,2005 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: HTML.pm,v 1.2 2005/01/26 10:00:55 naney Exp $
#
#

package WiKicker::DikiCGI::View::HTML;

use 5.005;
use strict;
use WiKicker::CGI::View::HTML;

use vars qw(@ISA);
BEGIN {
  @ISA = qw(WiKicker::CGI::View::HTML);
}

sub stylesheet_uri_list {
  my $self = shift;

  $self->request->configuration->stylesheet_uri_list($self->request->url);
}

sub make_html_footer {
  my $self = shift;

  my $result = $self->_make_html_footer_from_text;
  $result .= '</div></body></html>';

  $self->response->add_content($result);
}

sub _make_html_footer_from_text {
  my $self = shift;

  my $footer = $self->load_footer_file('html.footer.file',
                                       '/WiKicker/DikiTemplate/HTML/footer.txt');

  $footer = $self->common_footer_text_filter($footer);
  return $footer;
}

sub make_link_element_list {
  my $self = shift;

  my @list;

  my $uri = $self->request->query->url . '/d/rss.rdf';

  $uri = WiKicker::HTML::escape_attribute($uri);
  push(@list, qq(<link rel="alternate" type="application/rss+xml" title="RSS" href="$uri">));

  return @list;
}



1;
