#
# WiKicker
#
#  Default.pm
#
#
# Copyright (C) 2003,2004 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: Default.pm,v 1.16 2004/12/13 12:53:46 naney Exp $
#
#

package WiKicker::Properties::Default;

use 5.005;
use strict;
use Carp;
use WiKicker::Properties;

use vars qw(@ISA $_first_new @_default_text_list);
BEGIN{
  @ISA = qw(WiKicker::Properties);
  $_first_new = 1;
}

sub new {
  my ($class, %options) = @_;

  if ($_first_new) {
    @_default_text_list = <DATA>;
    $_first_new = 0;
  }
  my $self = bless WiKicker::Properties->new(%options), $class;
  $self->_load_from_text_list(@_default_text_list);

  return $self;
}

sub self_last_modified {
  return 0;
}

sub set {
  croak q(Can't set the value to Default Properties);
}

sub load {
  croak q(Can't load to Default Properties);
}

sub load_file {
  croak q(Can't load to Default Properties);
}

sub properties_name {
  return __PACKAGE__;
}

1;
__DATA__
#
# wikiforum
#
wikicker.name: WikiForum[WiKicker]
#wikicker.home:
wikicler.database.directory:

#
# program
#
#program.sendmail:
program.gpg: gpg

#
# admin
#
#admin.name: unknown
#admin.notify.email

#
# gpg
#
gpg.home:

#
# html
#
html.stylesheet: wiki.css

#
# user
#
user.timezone: GMT

#
# touch
#
#touch.file:

#
# Amazon.co.jp
#
#Amazon.co.jp.AssociatesID: wwwnaneyorg-22

#
# export
#
# export.MessageBoard.file: /tmp/MessageBoard.html.in

#
# param
#
#param.ImageUploadPage.datadir:
param.ImageUploadPage.tmpdir: /tmp
#param.ImageUploadPage.ImageBaseUrl:


#
# pseudo page
#
pseudo.CreatePage: WiKicker::WikiCGI::Page::CreatePage
pseudo.IndexPage: WiKicker::WikiCGI::Page::IndexPage
pseudo.CopyPage: WiKicker::WikiCGI::Page::CopyPage
pseudo.SearchPage: WiKicker::WikiCGI::Page::SearchPage
pseudo.ImageUploadPage: WiKicker::WikiCGI::Page::ImageUploadPage
pseudo.RecentChanges: WiKicker::WikiCGI::Page::RecentChanges
pseudo.RecentLog: WiKicker::WikiCGI::Page::RecentLog
pseudo.RssPage: WiKicker::WikiCGI::Page::RssPage
#pseudo.WantedPages: WiKicker::WikiCGI::Page::WantedPages
pseudo.PreferencePage: WiKicker::WikiCGI::Page::PreferencePage

# view
view.redirect:    WiKicker::CGI::View::Redirect
view.notmodified: WiKicker::CGI::View::NotModified

view.read:               WiKicker::WikiCGI::View::HTML::Read
view.readcache:          WiKicker::WikiCGI::View::HTML::ReadCache
view.edit:               WiKicker::WikiCGI::View::HTML::Edit
view.preview:            WiKicker::WikiCGI::View::HTML::Preview
view.success:            WiKicker::WikiCGI::View::HTML::Success
view.create:             WiKicker::WikiCGI::View::HTML::Create
view.copy:               WiKicker::WikiCGI::View::HTML::Copy
view.search:             WiKicker::WikiCGI::View::HTML::Search
view.preference:         WiKicker::WikiCGI::View::HTML::Preference
view.rlog:               WiKicker::WikiCGI::View::HTML::Rlog
view.diff:               WiKicker::WikiCGI::View::HTML::Diff
view.confirmdelete:      WiKicker::WikiCGI::View::HTML::ConfirmDelete
view.conflict:           WiKicker::WikiCGI::View::HTML::Conflict
view.index:              WiKicker::WikiCGI::View::HTML::Index
view.recent:             WiKicker::WikiCGI::View::HTML::Recent
view.recentlog:          WiKicker::WikiCGI::View::HTML::RecentLog
view.wanted:             WiKicker::WikiCGI::View::HTML::Wanted
view.error:              WiKicker::WikiCGI::View::HTML::Error
view.busy:               WiKicker::WikiCGI::View::HTML::Busy
view.imageuploadform:    WiKicker::WikiCGI::View::HTML::ImageUploadForm
view.imageuploadsuccess: WiKicker::WikiCGI::View::HTML::ImageUploadSuccess

view.rss:      WiKicker::CGI::View::XML::Rss
view.read.raw: WiKicker::CGI::View::Raw::Read
view.read.txt: WiKicker::CGI::View::Text::Read
view.index.txt: WiKicker::WikiCGI::View::Text::Index

view.trackbackerror.xml:       WiKicker::CGI::View::XML::TrackBackError
view.trackbackpingsuccess.xml: WiKicker::CGI::View::XML::TrackBackPingSuccess

# view for diary
view.RecentDiaries: WiKicker::DikiCGI::View::HTML::RecentDiaries
view.ArticleDiaries: WiKicker::DikiCGI::View::HTML::ArticleDiaries
view.OneDayDiaries: WiKicker::DikiCGI::View::HTML::OneDayDiaries
view.TenDayDiaries: WiKicker::DikiCGI::View::HTML::TenDayDiaries
view.RecentKeywordDiaries: WiKicker::DikiCGI::View::HTML::RecentKeywordDiaries
