#
# WiKicker
#
#  WRI.pm
#
#
# Copyright (C) 2003,2004,2005 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: WRI.pm,v 1.7 2005/03/20 10:44:26 naney Exp $
#
#

package WiKicker::WRI;

use strict;
use WiKicker::HTML;
use WiKicker::ISBN;

sub original { shift->{original} }
sub canonical { return undef }

# $wri->get_link_url($env)
sub get_link_url { return '' }

# $wri->get_image_url($env)
sub get_image_url { return '' }

sub to_string { return shift->original; }

sub to_subject_string {
  my ($self, $env) = @_;

  return '' if $self->get_image_url($env);
  return $self->to_string;
}

sub to_html {
  my ($self, $content, $env) = @_;

  return WiKicker::HTML::escape($content || $self->to_string);
}

sub _set_original {
  my ($self, $value) = @_;

  $self->{original} = $value;
}

sub _make_url_link_html {
  my ($self, $content, $env) = @_;

  my $image_url = $self->get_image_url($env);
  return $self->_make_image_link_html($content, $image_url, $env)
    if $image_url ne '';

  my $content_string = WiKicker::HTML::escape($content || $self->to_string);

  my $href = WiKicker::HTML::escape_attribute($self->get_link_url($env));
  return qq(<a href="$href">$content_string</a>) if $href ne '';
  return $content_string;
}

sub _make_image_link_html {
  my ($self, $content, $image_url, $env) = @_;

  my $url     = $self->get_link_url($env);
  my $href    = WiKicker::HTML::escape_attribute($url);
  my $img_src = WiKicker::HTML::escape_attribute($image_url);
  my $alt     = WiKicker::HTML::escape_attribute($content || $self->to_string);

  if ($url ne '' && ($url ne $image_url)) {
    return qq(<a href="$href"><img src="$img_src" alt="$alt"></a>);
  }
  else {
    return qq(<img src="$img_src" alt="$alt">);
  }
}

1;
