#
# WiKicker
#
#  Gmtime.pm
#
#
# Copyright (C) 2003 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: Gmtime.pm,v 1.3 2004/05/30 04:10:01 naney Exp $
#
#

package WiKicker::WRI::Gmtime;

use strict;
use WiKicker::WRI::RWRN;
use WiKicker::Time;

use vars qw(@ISA);
@ISA = qw(WiKicker::WRI::RWRN);

sub gmt_time {
  shift->rest;
}

sub to_html {
  my ($self, $content, $env) = @_;

  my $zone = 'GMT';
  if ($env->user) {
    $zone = $env->user->timezone || 'GMT';
  }

  my $time_str;
  if ($env->localizer) {
    $time_str = $env->localizer->language_handle->date_html_str($self->gmt_time, $zone);
  }
  else {
    $time_str = WiKicker::Time::japanese_date_html_str($self->gmt_time, $zone);
  }

  return qq(<span class="date">$time_str</span>);
}

sub to_subject_string {
  my ($self, $env) = @_;

  #return WiKicker::Time::japanese_date_str($self->gmt_time, 'GMT');
  return WiKicker::Time::english_date_str($self->gmt_time, 'GMT');
}

1;
