#
# WiKicker
#
#  Image.pm
#
#
# Copyright (C) 2003 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: Imagemap.pm,v 1.2 2005/03/20 10:44:26 naney Exp $
#
#

package WiKicker::WRI::Imagemap;

use strict;
use WiKicker::WRI::RWRN;
use URI;

use vars qw(@ISA);
@ISA = qw(WiKicker::WRI::RWRN);

sub get_link_url {
  my ($self, $env) = @_;

  my $uri = URI->new($self->rest);
  $uri->query(undef);
  $uri->fragment(undef);
  my $path = $uri->path;
  $path =~ s/\.[^.]*$/.map/;
  $uri->path($path);
  return $uri->as_string;
}

sub get_image_url {
  my ($self, $env) = @_;

  return $self->rest;
}

sub to_html {
  my ($self, $content, $env) = @_;

  my $img_src = WiKicker::HTML::escape_attribute($self->get_image_url($env));
  my $href    = WiKicker::HTML::escape_attribute($self->get_link_url($env));
  my $alt     = WiKicker::HTML::escape_attribute($content || $self->to_string);
  return qq(<a href="$href"><img ismap src="$img_src" alt="$alt"></a>);
}


1;
