#
# WiKicker
#
#  Search.pm
#
#
# Copyright (C) 2003 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: Search.pm,v 1.2 2003/06/28 03:21:54 naney Exp $
#
#

package WiKicker::WRI::Search;

use strict;
use WiKicker::WRI::RWRN;
use WiKicker::Loader;

use vars qw(@ISA);
@ISA = qw(WiKicker::WRI::RWRN);

sub to_html {
  my ($self, $content, $env) = @_;

  my $target = $self->rest;
  my $url = $env->wikicker_url
    . '?search=' . WiKicker::URI::escape_URI($target);
  my $title = WiKicker::HTML::escape_attribute(qq(Search '$target' from WikiPages'));
  $content = WiKicker::HTML::escape($content || $self->original);
  return qq(<a href="$url" title="$title">$content</a>);
}

1;
