#
# WiKicker
#
#  Conflict.pm
#
#
# Copyright (C) 2003 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: Conflict.pm,v 1.3 2004/05/01 07:06:08 naney Exp $
#
#

package WiKicker::WikiCGI::View::HTML::Conflict;

use 5.005;
use strict;

use WiKicker::WikiCGI::View::HTML;
use WiKicker::PageName;

use vars qw(@ISA);
@ISA = qw(WiKicker::WikiCGI::View::HTML);

sub make_html_body {
  my $self = shift;

  my $wiki_page = $self->request->attribute('content');

  $self->response->add_content($self->make_conflict($wiki_page, $self->request));
}

sub make_conflict {
  my ($self, $wiki_page, $request) = @_;

  my $query = $request->query;

  my $row = 20;
  my $column = 80;

  my $result;
  $result .= '<p>Conflict your message. Please save your message and reedit current page.</p>';
  $result .= "<!-- begin edit form -->\n";
  $result .= $query->start_form(-method => 'POST',
                                -action => $self->request->url);
  $result .= '  ';
  # hidden
  # text area
  $result .= $query->textarea(-name => 'content',
                              -default => $wiki_page,
                              -override => 1,
                              -rows => $row,
                              -columns => $column);
  $result .= $query->end_form;
  $result .= "\n<!-- end edit form -->\n";
  return $result;
}

1;
