#
# WiKicker
#
#  Preference.pm
#
#
# Copyright (C) 2003,2004 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: Preference.pm,v 1.6 2005/01/09 12:59:22 naney Exp $
#
#

package WiKicker::WikiCGI::View::HTML::Preference;

use 5.005;
use strict;

use WiKicker::WikiCGI::View::HTML;

use vars qw(@ISA);
@ISA = qw(WiKicker::WikiCGI::View::HTML);

sub make_html_body {
  my $self = shift;

  $self->response->add_content($self->make_preference_form);
}

sub make_preference_form {
  my $self = shift;

  my $query = $self->request->query;

  my $time_zone_str = $self->request->maketext('time zone');
  my $name_str = $self->request->maketext('name (nickname)');
  my $update_str = $self->request->maketext('update');

  my $result;
  $result .= $query->start_form(-method => 'POST',
                                -action => $self->request->url);
  $result .= $query->hidden(-name => 'name',
                            -default => 'PreferencePage',
                            -override => 1);
  $result .= $query->hidden(-name => 'action',
                            -default => 'commit',
                            -override => 1);
  $result .= qq($name_str: );
  $result .= $query->textfield(-name => 'un',
                               -default => $self->request->user->name,
                               -override => 1,
                               -size => 30,
                               -maxlength => 120);
  $result .= "<br>\n";


  $result .= qq($time_zone_str: );
  $result .= $query->textfield(-name => 'tz',
                               -default => $self->request->user->timezone ||
                               $self->request->configuration->properties->get('user.timezone'),
                               -override => 1,
                               -size => 30,
                               -maxlength => 120);
  $result .= "<br>\n";
  $result .= qq(editor width: );
  $result .= $query->textfield(-name => 'ew',
                               -default => $self->request->user->editor_width,
                               -override => 1,
                               -size => 3,
                               -maxlength => 10);

  $result .= "<br>\n";
  $result .= qq(editor height: );
  $result .= $query->textfield(-name => 'eh',
                               -default => $self->request->user->editor_height,
                               -override => 1,
                               -size => 3,
                               -maxlength => 10);

  $result .= "<br>\n";
  $result .= $query->submit(-name => 'submit',
                            -value => $update_str);

  $result .= '</form>';
  return $result;
};

1;
