#
# WiKicker
#
#  Search.pm
#
#
# Copyright (C) 2003,2004,2005 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: Search.pm,v 1.4 2005/01/09 12:59:22 naney Exp $
#
#

package WiKicker::WikiCGI::View::HTML::Search;

use 5.005;
use strict;

use WiKicker::WikiCGI::View::HTML;
use WiKicker::PageName;

use vars qw(@ISA);
@ISA = qw(WiKicker::WikiCGI::View::HTML);

sub make_html_body {
  my $self = shift;

  $self->response->add_content($self->make_search_form);
}

sub make_search_form {
  my $self = shift;

  my $query = $self->request->query;

  my $result;
  $result .= $query->start_form(-method => 'POST',
                                -action => $self->request->url);
  $result .= $query->hidden(-name => 'action',
                            -default => 'search',
                            -override => 1);
  $result .= $query->textfield(-name => 'name',
                               -default => '',
                               -override => 1,
                               -size => 30,
                               -maxlength => 120); #@todo max length;
  $result .= $query->submit(-name => 'submit', -value => 'search');
  $result .= '</form>';

  return $result;
};

1;
