#
# WiKicker
#
#  BracketNameNode.pm
#
#
# Copyright (C) 2003,2004 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: BracketNameNode.pm,v 1.6 2004/06/11 14:50:39 naney Exp $
#
#

package WiKicker::WikiPage::BracketNameNode;

use strict;
use WiKicker::WikiPage::Acceptor qw(:accept);
use WiKicker::WikiPage::WriNode;

use vars qw(@ISA);
@ISA = qw(WiKicker::WikiPage::WriNode);

sub new {
  my ($class, $original, $reference, $content, $wri_factory) = @_;

  my $self =
    bless WiKicker::WikiPage::WriNode->new($original, $reference, $wri_factory), $class;
  $self->reference($reference);
  $self->content($content);

  return $self;
}

sub reference {
  my ($self, $value) = @_;

  if (defined $value) {
    $self->{reference} = $value;
  }
  return $self->{reference};
}

sub content {
  my ($self, $value) = @_;

  if (defined $value) {
    $self->{content} = $value;
  }
  return $self->{content};
}

sub to_unarmor_string {
  my $self = shift;

  if ($self->content) {
    return $self->content;
  }

  return $self->wri->to_string;
}

sub is_empty_bracket_name {
  my $self = shift;

  return $self->original =~ /^\[\[\s*\]\]$/;
}

1;
