#
# WiKicker
#
#  GetSectionRawVisitor.pm
#
#
# Copyright (C) 2003 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: GetSectionRawVisitor.pm,v 1.5 2004/08/03 12:55:52 naney Exp $
#
#

package WiKicker::WikiPage::GetSectionRawVisitor;

use strict;

use WiKicker::WikiPage::TraverseVisitor;
use vars qw(@ISA);
@ISA = qw(WiKicker::WikiPage::TraverseVisitor);

sub section_number {
  my ($self, $value) = @_;

  if (defined $value) {
    $self->{section_number} = $value;
  }
  return $self->{section_number};
}

sub new {
  my $class = shift;

  my $self = bless { section => '' }, $class;

  return $self;
}

sub visit_DocumentNode {
  my ($self, $document_node) = @_;

  my $number = 0;
  for my $node ($document_node->nodes) {
    if ($node->isa('WiKicker::WikiPage::HeadingNode')) {
      if ($node->level <= 2) {
        $number++;
      }
    }
    if ($number == $self->section_number) {
      $self->{section} .= $node->to_string;
    }
  }
}

sub section {
  my $self = shift;

  return $self->{section};
}

1;
