#
# WiKicker
#
#  TableRecordNode.pm
#
#
# Copyright (C) 2003 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: TableRecordNode.pm,v 1.2 2003/10/26 00:29:54 naney Exp $
#
#

package WiKicker::WikiPage::TableRecordNode;

use strict;
use WiKicker::WikiPage::Acceptor;
use WiKicker::WikiPage::Node;

use vars qw(@ISA);

@ISA = qw(WiKicker::WikiPage::Acceptor WiKicker::WikiPage::Node);

sub cr {
  my ($self, $value) = @_;

  if (defined $value) {
    $self->{cr} = $value;
  }
  return $self->{cr};
}

sub to_string {
  my $self = shift;

  my $cr = '';
  $cr = $self->cr if defined $self->cr;

  return join('', map { $_->to_string } $self->nodes) . $cr;
}

sub to_unarmor_string {
  my $self = shift;

  my $cr = '';
  $cr = $self->cr if defined $self->cr;

  return join('', map { $_->to_unarmor_string } $self->nodes) . $cr;
}

1;
