#
# WiKicker
#
#  TraverseVisotor.pm
#
#
# Copyright (C) 2003,2004 WATANABE Yoshimasa <naney@naney.org>
#
# This file is part of the WiKicker.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
# $Id: TraverseVisitor.pm,v 1.2 2004/02/11 07:00:34 naney Exp $
#
#

package WiKicker::WikiPage::TraverseVisitor;

use strict;

use WiKicker::WikiPage::Visitor;
use vars qw(@ISA);
@ISA = qw(WiKicker::WikiPage::Visitor);

sub visit_Inline {
  my ($self, $inline) = @_;

  $self->_visit_node($inline);
}

sub visit_DocumentNode {
  my ($self, $document_node) = @_;
  $self->_visit_node($document_node);
}

sub visit_ParagraphNode {
  my ($self, $paragraph_node) = @_;
  $self->_visit_node($paragraph_node);
}

sub visit_TableNode {
  my ($self, $table_node) = @_;
  $self->_visit_node($table_node);
}

sub visit_TableRecordNode {
  my ($self, $record_node) = @_;
  $self->_visit_node($record_node);
}

sub visit_TableCellNode {
  my ($self, $cell_node) = @_;
  $self->_visit_node($cell_node);
}

sub visit_EmphasisNode {
  my ($self, $emphasis_node) = @_;
  $self->_visit_node($emphasis_node)
}

sub visit_InlineBlockNode {
  my ($self, $inline_block_node) = @_;
  $self->_visit_node($inline_block_node)
}

sub visit_HeadingNode {
  my ($self, $heading_node) = @_;
  $self->_visit_node($heading_node);
}

sub visit_HrNode {
  my ($self, $hr_node) = @_;
}

sub visit_PreNode {
  my ($self, $pre_node) = @_;
}

sub visit_TextNode {
  my ($self, $text) = @_;

}

sub visit_VerbatimNode {
  my ($self, $node) = @_;
}

sub visit_WriNode {
  my ($self, $wri_node) = @_;

}

sub visit_BracketNameNode {
  my ($self, $bracket_name_node) = @_;

}

sub visit_EmptyLinesNode {
  my ($self, $empty_lines_node) = @_;

}

sub visit_ListNode {
  my ($self, $list_node) = @_;
  $self->_visit_node($list_node);
}

sub visit_DlNode {
  my ($self, $dl_node) = @_;
  $self->_visit_node($dl_node);
}

sub visit_QuoteNode {
  my ($self, $quote_node) = @_;
  $self->_visit_node($quote_node);
}

sub visit_ListItemNode {
  my ($self, $li_node) = @_;
  $self->_visit_node($li_node);
}  

sub visit_DtNode {
  my ($self, $dt_node) = @_;
  $self->_visit_node($dt_node);
}  

sub visit_DdNode {
  my ($self, $dd_node) = @_;
  $self->_visit_node($dd_node);
}  

sub visit_QuoteLineNode {
  my ($self, $line_node) = @_;
  $self->_visit_node($line_node);
}

sub _visit_node {
  my ($self, $current_node) = @_;
  for my $node ($current_node->nodes) {
    $self->{parent} = $current_node;
    $node->accept($self);
  }
}


1;
